diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lte/model/lte-ue-power-control.h ns-3.44/src/lte/model/lte-ue-power-control.h
--- ns-3.43/src/lte/model/lte-ue-power-control.h	2024-10-09 16:41:10.044656500 -0700
+++ ns-3.44/src/lte/model/lte-ue-power-control.h	2025-03-09 16:55:49.607372000 -0700
@@ -10,9 +10,9 @@
 #ifndef LTE_UE_POWER_CONTROL_H
 #define LTE_UE_POWER_CONTROL_H
 
-#include <ns3/object.h>
-#include <ns3/ptr.h>
-#include <ns3/traced-callback.h>
+#include "ns3/object.h"
+#include "ns3/ptr.h"
+#include "ns3/traced-callback.h"
 
 #include <vector>
 
@@ -20,7 +20,7 @@
 {
 
 /**
- * \brief This class realizes Uplink Power Control functionality
+ * @brief This class realizes Uplink Power Control functionality
  *
  * When LteUePhy is about sending PUSCH/PUCCH/SRS it should ask
  * LteUePowerControl for current channel TX power level and then
@@ -47,8 +47,8 @@
     ~LteUePowerControl() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     // inherited from Object
@@ -56,82 +56,82 @@
     void DoDispose() override;
 
     /**
-     * \brief Set PC maximum function
+     * @brief Set PC maximum function
      *
-     * \param value the PC maximum value
+     * @param value the PC maximum value
      */
     void SetPcmax(double value);
     /**
-     * \brief Get PC maximum function
+     * @brief Get PC maximum function
      *
-     * \returns the PC maximum value
+     * @returns the PC maximum value
      */
     double GetPcmax();
 
     /**
-     * \brief Set transmit power function
+     * @brief Set transmit power function
      *
-     * \param value the transmit power value
+     * @param value the transmit power value
      */
     void SetTxPower(double value);
     /**
-     * \brief Configure reference signal power (dBm) function
+     * @brief Configure reference signal power (dBm) function
      *
-     * \param referenceSignalPower the reference signal power
+     * @param referenceSignalPower the reference signal power
      */
     void ConfigureReferenceSignalPower(int8_t referenceSignalPower);
 
     /**
-     * \brief Set the cell ID function
+     * @brief Set the cell ID function
      *
-     * \param cellId the cell ID
+     * @param cellId the cell ID
      */
     void SetCellId(uint16_t cellId);
     /**
-     * \brief Set the RNTI function
+     * @brief Set the RNTI function
      *
-     * \param rnti the RNTI
+     * @param rnti the RNTI
      */
     void SetRnti(uint16_t rnti);
 
     /**
-     * \brief Set PO nominal PUSCH function
+     * @brief Set PO nominal PUSCH function
      *
-     * \param value the value to set
+     * @param value the value to set
      */
     void SetPoNominalPusch(int16_t value);
     /**
-     * \brief Set PO UE PUSCH function
+     * @brief Set PO UE PUSCH function
      *
-     * \param value the value to set
+     * @param value the value to set
      */
     void SetPoUePusch(int16_t value);
     /**
-     * \brief Set alpha function
+     * @brief Set alpha function
      *
-     * \param value the alpha value to set
+     * @param value the alpha value to set
      */
     void SetAlpha(double value);
 
     /**
-     * \brief Set RSRP function
+     * @brief Set RSRP function
      *
-     * \param value the RSRP (dBm) value to set
+     * @param value the RSRP (dBm) value to set
      */
     void SetRsrp(double value);
     /**
-     * \brief Set RSRP function
+     * @brief Set RSRP function
      *
-     * \param rsrpFilterCoefficient value. Determines the strength of
+     * @param rsrpFilterCoefficient value. Determines the strength of
      * smoothing effect induced by layer 3 filtering of RSRP
      * used for uplink power control in all attached UE.
      * If equals to 0, no layer 3 filtering is applicable.
      */
     void SetRsrpFilterCoefficient(uint8_t rsrpFilterCoefficient);
     /**
-     * \brief Set RSRP function
+     * @brief Set RSRP function
      *
-     * \param tpc the TPC to report
+     * @param tpc the TPC to report
      */
     void ReportTpc(uint8_t tpc);
 
@@ -143,33 +143,33 @@
     void CalculateSrsTxPower();
 
     /**
-     * \brief Get PUSCH transmit power function
+     * @brief Get PUSCH transmit power function
      *
-     * \param rb the DL RB list
-     * \returns the PUSCH transmit power
+     * @param rb the DL RB list
+     * @returns the PUSCH transmit power
      */
     double GetPuschTxPower(std::vector<int> rb);
     /**
-     * \brief Get PUCCH transmit power function
+     * @brief Get PUCCH transmit power function
      *
-     * \param rb unused
-     * \returns the PUCCH transmit power
+     * @param rb unused
+     * @returns the PUCCH transmit power
      */
     double GetPucchTxPower(std::vector<int> rb);
     /**
-     * \brief Get SRS transmit power function
+     * @brief Get SRS transmit power function
      *
-     * \param rb the DL RB list
-     * \returns the SRS transmit power
+     * @param rb the DL RB list
+     * @returns the SRS transmit power
      */
     double GetSrsTxPower(std::vector<int> rb);
 
     /**
      * TracedCallback signature for uplink transmit power.
      *
-     * \param [in] cellId Cell identifier.
-     * \param [in] rnti The C-RNTI identifying the UE.
-     * \param [in] power The current TX power.
+     * @param [in] cellId Cell identifier.
+     * @param [in] rnti The C-RNTI identifying the UE.
+     * @param [in] power The current TX power.
      */
     typedef void (*TxPowerTracedCallback)(uint16_t cellId, uint16_t rnti, double power);
 
@@ -177,7 +177,7 @@
     /**
      * Set subchannel mask function
      *
-     * \param [in] mask the subchannel mask
+     * @param [in] mask the subchannel mask
      */
     void SetSubChannelMask(std::vector<int> mask);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lte/model/lte-ue-rrc.cc ns-3.44/src/lte/model/lte-ue-rrc.cc
--- ns-3.43/src/lte/model/lte-ue-rrc.cc	2024-10-09 16:41:10.044656500 -0700
+++ ns-3.44/src/lte/model/lte-ue-rrc.cc	2025-03-09 16:55:49.607372000 -0700
@@ -22,11 +22,11 @@
 #include "lte-rlc-um.h"
 #include "lte-rlc.h"
 
-#include <ns3/fatal-error.h>
-#include <ns3/log.h>
-#include <ns3/object-factory.h>
-#include <ns3/object-map.h>
-#include <ns3/simulator.h>
+#include "ns3/fatal-error.h"
+#include "ns3/log.h"
+#include "ns3/object-factory.h"
+#include "ns3/object-map.h"
+#include "ns3/simulator.h"
 
 #include <cmath>
 
@@ -47,7 +47,7 @@
     /**
      * Constructor
      *
-     * \param rrc the RRC class
+     * @param rrc the RRC class
      */
     UeMemberLteUeCmacSapUser(LteUeRrc* rrc);
 
@@ -82,23 +82,6 @@
     m_rrc->DoNotifyRandomAccessFailed();
 }
 
-/// Map each of UE RRC states to its string representation.
-static const std::string g_ueRrcStateName[LteUeRrc::NUM_STATES] = {
-    "IDLE_START",
-    "IDLE_CELL_SEARCH",
-    "IDLE_WAIT_MIB_SIB1",
-    "IDLE_WAIT_MIB",
-    "IDLE_WAIT_SIB1",
-    "IDLE_CAMPED_NORMALLY",
-    "IDLE_WAIT_SIB2",
-    "IDLE_RANDOM_ACCESS",
-    "IDLE_CONNECTING",
-    "CONNECTED_NORMALLY",
-    "CONNECTED_HANDOVER",
-    "CONNECTED_PHY_PROBLEM",
-    "CONNECTED_REESTABLISHING",
-};
-
 /////////////////////////////
 // ue RRC methods
 /////////////////////////////
@@ -625,7 +608,7 @@
         break;
 
     default: // i.e. IDLE_RANDOM_ACCESS
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -649,7 +632,7 @@
 void
 LteUeRrc::DoNotifyRandomAccessSuccessful()
 {
-    NS_LOG_FUNCTION(this << m_imsi << ToString(m_state));
+    NS_LOG_FUNCTION(this << m_imsi << m_state);
     m_randomAccessSuccessfulTrace(m_imsi, m_cellId, m_rnti);
 
     switch (m_state)
@@ -685,7 +668,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("unexpected event in state " << ToString(m_state));
+        NS_FATAL_ERROR("unexpected event in state " << m_state);
         break;
     }
 }
@@ -693,7 +676,7 @@
 void
 LteUeRrc::DoNotifyRandomAccessFailed()
 {
-    NS_LOG_FUNCTION(this << m_imsi << ToString(m_state));
+    NS_LOG_FUNCTION(this << m_imsi << m_state);
     m_randomAccessErrorTrace(m_imsi, m_cellId, m_rnti);
 
     switch (m_state)
@@ -707,7 +690,7 @@
     case CONNECTED_HANDOVER: {
         m_handoverEndErrorTrace(m_imsi, m_cellId, m_rnti);
         /**
-         * \todo After a handover failure because of a random access failure,
+         * @todo After a handover failure because of a random access failure,
          *       send an RRC Connection Re-establishment and switch to
          *       CONNECTED_REESTABLISHING state.
          */
@@ -725,7 +708,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("unexpected event in state " << ToString(m_state));
+        NS_FATAL_ERROR("unexpected event in state " << m_state);
         break;
     }
 }
@@ -741,8 +724,7 @@
 LteUeRrc::DoStartCellSelection(uint32_t dlEarfcn)
 {
     NS_LOG_FUNCTION(this << m_imsi << dlEarfcn);
-    NS_ASSERT_MSG(m_state == IDLE_START,
-                  "cannot start cell selection from state " << ToString(m_state));
+    NS_ASSERT_MSG(m_state == IDLE_START, "cannot start cell selection from state " << m_state);
     m_dlEarfcn = dlEarfcn;
     m_cphySapProvider.at(0)->StartCellSearch(dlEarfcn);
     SwitchToState(IDLE_CELL_SEARCH);
@@ -765,7 +747,7 @@
     case IDLE_CELL_SEARCH:
     case IDLE_WAIT_MIB_SIB1:
     case IDLE_WAIT_SIB1:
-        NS_FATAL_ERROR("cannot abort cell selection " << ToString(m_state));
+        NS_FATAL_ERROR("cannot abort cell selection " << m_state);
         break;
 
     case IDLE_WAIT_MIB:
@@ -787,7 +769,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("unexpected event in state " << ToString(m_state));
+        NS_FATAL_ERROR("unexpected event in state " << m_state);
         break;
     }
 }
@@ -825,7 +807,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("unexpected event in state " << ToString(m_state));
+        NS_FATAL_ERROR("unexpected event in state " << m_state);
         break;
     }
 }
@@ -1032,7 +1014,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1136,7 +1118,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1149,7 +1131,7 @@
     {
     case CONNECTED_REESTABLISHING: {
         /**
-         * \todo After receiving RRC Connection Re-establishment, stop timer
+         * @todo After receiving RRC Connection Re-establishment, stop timer
          *       T301, fire a new trace source, reply with RRC Connection
          *       Re-establishment Complete, and finally switch to
          *       CONNECTED_NORMALLY state. See Section 5.3.7.5 of 3GPP TS
@@ -1159,7 +1141,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1173,7 +1155,7 @@
     {
     case CONNECTED_REESTABLISHING: {
         /**
-         * \todo After receiving RRC Connection Re-establishment Reject, stop
+         * @todo After receiving RRC Connection Re-establishment Reject, stop
          *       timer T301. See Section 5.3.7.8 of 3GPP TS 36.331.
          */
         m_asSapUser->NotifyConnectionReleased(); // Inform upper layers
@@ -1181,7 +1163,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1190,7 +1172,7 @@
 LteUeRrc::DoRecvRrcConnectionRelease(LteRrcSap::RrcConnectionRelease msg)
 {
     NS_LOG_FUNCTION(this << " RNTI " << m_rnti);
-    /// \todo Currently not implemented, see Section 5.3.8 of 3GPP TS 36.331.
+    /// @todo Currently not implemented, see Section 5.3.8 of 3GPP TS 36.331.
 
     m_lastRrcTransactionIdentifier = msg.rrcTransactionIdentifier;
     // release resources at UE
@@ -1318,7 +1300,7 @@
         // and start random access.
         if (!m_connectionPending)
         {
-            NS_LOG_DEBUG("Calling DoConnect in state = " << ToString(m_state));
+            NS_LOG_DEBUG("Calling DoConnect in state = " << m_state);
             DoConnect();
         }
         SwitchToState(IDLE_CAMPED_NORMALLY);
@@ -1428,7 +1410,7 @@
         {
             // SRB1 not setup yet
             NS_ASSERT_MSG((m_state == IDLE_CONNECTING) || (m_state == CONNECTED_HANDOVER),
-                          "unexpected state " << ToString(m_state));
+                          "unexpected state " << m_state);
             NS_ASSERT_MSG(stamIt->srbIdentity == 1, "only SRB1 supported");
 
             const uint8_t lcid = 1; // fixed LCID for SRB1
@@ -1593,7 +1575,7 @@
         {
             NS_LOG_INFO("request to modify existing DRBID");
             Ptr<LteDataRadioBearerInfo> drbInfo = drbMapIt->second;
-            /// \todo currently not implemented. Would need to modify drbInfo, and then propagate
+            /// @todo currently not implemented. Would need to modify drbInfo, and then propagate
             /// changes to the MAC
         }
     }
@@ -1888,9 +1870,9 @@
         storedMeasIt = ret.first;
     }
 
-    NS_LOG_DEBUG(this << " IMSI " << m_imsi << " state " << ToString(m_state) << ", measured cell "
-                      << cellId << ", carrier component Id " << componentCarrierId << ", new RSRP "
-                      << rsrp << " stored " << storedMeasIt->second.rsrp << ", new RSRQ " << rsrq
+    NS_LOG_DEBUG(this << " IMSI " << m_imsi << " state " << m_state << ", measured cell " << cellId
+                      << ", carrier component Id " << componentCarrierId << ", new RSRP " << rsrp
+                      << " stored " << storedMeasIt->second.rsrp << ", new RSRQ " << rsrq
                       << " stored " << storedMeasIt->second.rsrq);
 
 } // end of void SaveUeMeasurements
@@ -2696,13 +2678,7 @@
     {
         NS_ASSERT(it2->measId == measId);
 
-        for (auto it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
-        {
-            if (*it3 == cellId)
-            {
-                it3 = it2->concernedCells.erase(it3);
-            }
-        }
+        it2->concernedCells.remove_if([cellId](auto cell) { return cellId == cell; });
 
         if (it2->concernedCells.empty())
         {
@@ -2753,13 +2729,7 @@
     {
         NS_ASSERT(it2->measId == measId);
 
-        for (auto it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
-        {
-            if (*it3 == cellId)
-            {
-                it3 = it2->concernedCells.erase(it3);
-            }
-        }
+        it2->concernedCells.remove_if([cellId](auto cell) { return cellId == cell; });
 
         if (it2->concernedCells.empty())
         {
@@ -3214,11 +3184,11 @@
 void
 LteUeRrc::SwitchToState(State newState)
 {
-    NS_LOG_FUNCTION(this << ToString(newState));
+    NS_LOG_FUNCTION(this << newState);
     State oldState = m_state;
     m_state = newState;
-    NS_LOG_INFO(this << " IMSI " << m_imsi << " RNTI " << m_rnti << " UeRrc " << ToString(oldState)
-                     << " --> " << ToString(newState));
+    NS_LOG_INFO(this << " IMSI " << m_imsi << " RNTI " << m_rnti << " UeRrc " << oldState << " --> "
+                     << newState);
     m_stateTransitionTrace(m_imsi, m_cellId, m_rnti, oldState, newState);
 
     switch (newState)
@@ -3332,7 +3302,46 @@
 const std::string
 LteUeRrc::ToString(LteUeRrc::State s)
 {
-    return g_ueRrcStateName[s];
+    std::ostringstream ss;
+    ss << s;
+    return ss.str();
+}
+
+std::ostream&
+operator<<(std::ostream& os, LteUeRrc::State state)
+{
+    switch (state)
+    {
+    case LteUeRrc::State::IDLE_START:
+        return os << "IDLE_START";
+    case LteUeRrc::State::IDLE_CELL_SEARCH:
+        return os << "IDLE_CELL_SEARCH";
+    case LteUeRrc::State::IDLE_WAIT_MIB_SIB1:
+        return os << "IDLE_WAIT_MIB_SIB1";
+    case LteUeRrc::State::IDLE_WAIT_MIB:
+        return os << "IDLE_WAIT_MIB";
+    case LteUeRrc::State::IDLE_WAIT_SIB1:
+        return os << "IDLE_WAIT_SIB1";
+    case LteUeRrc::State::IDLE_CAMPED_NORMALLY:
+        return os << "IDLE_CAMPED_NORMALLY";
+    case LteUeRrc::State::IDLE_WAIT_SIB2:
+        return os << "IDLE_WAIT_SIB2";
+    case LteUeRrc::State::IDLE_RANDOM_ACCESS:
+        return os << "IDLE_RANDOM_ACCESS";
+    case LteUeRrc::State::IDLE_CONNECTING:
+        return os << "IDLE_CONNECTING";
+    case LteUeRrc::State::CONNECTED_NORMALLY:
+        return os << "CONNECTED_NORMALLY";
+    case LteUeRrc::State::CONNECTED_HANDOVER:
+        return os << "CONNECTED_HANDOVER";
+    case LteUeRrc::State::CONNECTED_PHY_PROBLEM:
+        return os << "CONNECTED_PHY_PROBLEM";
+    case LteUeRrc::State::CONNECTED_REESTABLISHING:
+        return os << "CONNECTED_REESTABLISHING";
+    case LteUeRrc::State::NUM_STATES:
+        return os << "NUM_STATES";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(state) << ")";
 }
 
 } // namespace ns3
